## net.sf.saxon.om
Class Navigator.DescendantEnumeration

    java.lang.Object
      net.sf.saxon.om.AxisIteratorImpl
          net.sf.saxon.om.Navigator.BaseEnumeration
              net.sf.saxon.om.Navigator.DescendantEnumeration

All Implemented Interfaces:
  AtomizableIterator, AxisIterator, SequenceIterator

Enclosing class:
  Navigator

public static final class Navigator.DescendantEnumeration
extends Navigator.BaseEnumeration

General-purpose implementation of the descendant and descendant-or-self axes, in terms of the child axis. But it also has the option to return the descendants in reverse document order; this is used when evaluating the preceding axis. Note that the includeSelf option should not be used when scanning in reverse order, as the self node will always be returned first.

Field Summary

Fields inherited from class net.sf.saxon.om.AxisIteratorImpl
`current, position`

Constructor Summary
`Navigator.DescendantEnumeration(NodeInfo start, boolean includeSelf, boolean forwards)`

Method Summary
`void` `advance()` The advance() method must be provided in each concrete implementation.
`SequenceIterator` `getAnother()` Get another iterator over the same sequence of items, positioned at the start of the sequence

Methods inherited from class net.sf.saxon.om.Navigator.BaseEnumeration
`next`

Methods inherited from class net.sf.saxon.om.AxisIteratorImpl
`current, isAtomizing, position, setIsAtomizing`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Navigator.DescendantEnumeration

    public Navigator.DescendantEnumeration(NodeInfo start,
                                           boolean includeSelf,
                                           boolean forwards)

Method Detail

### advance

    public void advance()

  Description copied from class: `Navigator.BaseEnumeration`
  The advance() method must be provided in each concrete implementation. It must leave the variable current set to the next node to be returned in the iteration, or to null if there are no more nodes to be returned.

  Specified by:
    `advance` in class `Navigator.BaseEnumeration`

### getAnother

    public SequenceIterator getAnother()

  Description copied from interface: `AxisIterator`
  Get another iterator over the same sequence of items, positioned at the start of the sequence

  Specified by:
    `getAnother` in interface `AxisIterator`
  Specified by:
    `getAnother` in class `Navigator.BaseEnumeration`